drop function addhit(text,text,text,text,text,text,
  text,int4,int4,text,text,text,text,text);

create function addhit(text,text,text,text,text,text,
 text,int4,int4,text,text,text,text,text) returns int4 as '
  declare
    p_CustomerText	alias for $1;
    p_IPText		alias for $2;
    p_AuthUser		alias for $3;
    p_AuthName		alias for $4;
    p_hitDatetime	alias for $5;
    p_HostText		alias for $6;
    p_URLText		alias for $7;
    p_Status		alias for $8;
    p_Size		alias for $9;
    p_RefererHostText	alias for $10;
    p_RefererURLText	alias for $11;
    p_BrowserText	alias for $12;
    p_XferTime          alias for $13;
    p_MimeTypeText	alias for $14;

    v_CustomerID	int4; -- hit.CustomerID%rowtype;
    v_IPID		int4; -- hit.IPID%rowtype;
    v_HostID		int4;
    v_URLID		int4; -- hit.URLID%rowtype;
    v_RefererHostID	int4;
    v_RefererURLID	int4;
    v_BrowserID		int4;
    v_MimeTypeID	int4;

--    referer		record;
--    v_refererTimeSpent	interval;
--    v_return		int4;
  begin
    v_CustomerID	:= getCustomerID(p_CustomerText);
    v_IPID		:= getIPID(p_IPText);
    v_HostID		:= getHostID(p_HostText);
    v_URLID		:= getURLID(p_URLText);
    v_RefererHostID	:= getHostID(p_RefererHostText);
    v_RefererURLID	:= getURLID(p_RefererURLText);
    v_BrowserID		:= getBrowserID(p_BrowserText);
    v_MimeTypeID	:= getMimeTypeID(p_MimeTypeText);

    insert into hit(CustomerID,IPID,AuthUser,AuthName,hitDatetime,
       HostID,URLID,Status,Size,RefererHostID,RefererURLID,BrowserID,
       XferTime, MimeTypeID)
--     HostID,URLID,Status,Size,RefererHostID,RefererURLID,BrowserID,TimeSpent)
    values(
      v_CustomerID,
      v_IPID,
      p_AuthUser,
      p_AuthName,
      p_hitDatetime,
      v_HostID,
      v_URLID,
      p_Status,
      p_Size,
      v_RefererHostID,
      v_RefererURLID,
      v_BrowserID,
      p_XferTime,
      v_MimeTypeID
    );
--    v_return=1;
--    if p_find_timespent = ''1'' then
--	v_return=v_return+20;
--	select hitID,hitdatetime into referer from hit
--	   where IPID		= v_IPID
--	   and   CustomerID	= v_CustomerID
--	   and   URLID		= v_RefererURLID
--	   and   hitDateTime	<= p_hitDateTime::timestamp
--	   order by HitDateTime desc;
--	if not found then
--	--
--	else
--	  v_refererTimeSpent	:= age(p_hitDateTime,referer.hitDateTime);
--	  -- should be: update hit set timespent = timestamp(v_refererTimeSpent)
--	  update hit set timespent = p_hitDateTime
--	     where hitid=referer.hitid;
--	  v_return = v_return + 10;
--	end if;
--    end if;
--
--    return v_return;      
    return 0;      
  end;
' language 'PLpgSQL';

